unit frmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, FileCtrl,
  IniFiles, ActnList, ToolWin, XPMenu, ImgList, BULogFile, BUThread,
  BUDragDrop, StdCtrls, OoMisc, AdPort, BURunOnStartup;

type

  TfmMain = class(TForm)
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Ouvrir1: TMenuItem;
    Sauver1: TMenuItem;
    Sauversous1: TMenuItem;
    Imprimer1: TMenuItem;
    Configurerimprimante1: TMenuItem;
    N2: TMenuItem;
    Quitter1: TMenuItem;
    Aide1: TMenuItem;
    Indexdelaide1: TMenuItem;
    N3: TMenuItem;
    Apropos1: TMenuItem;
    StatusBar1: TStatusBar;
    lvEventsList: TListView;
    ActionList1: TActionList;
    ActAppResetAll: TAction;
    ActAppClose: TAction;
    ActFileOpen: TAction;
    ActFileSave: TAction;
    ActFileSaveAs: TAction;
    ActPrint: TAction;
    ActPrintConf: TAction;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    PopupMenu1: TPopupMenu;
    Ouvrir2: TMenuItem;
    Sauver2: TMenuItem;
    Sauversous2: TMenuItem;
    N4: TMenuItem;
    Imprimer2: TMenuItem;
    ActOptions: TAction;
    Options1: TMenuItem;
    N5: TMenuItem;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ActCaptureStart: TAction;
    ActCaptureStop: TAction;
    Capture1: TMenuItem;
    Dmarrer1: TMenuItem;
    Arrter1: TMenuItem;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    XPMenu1: TXPMenu;
    ImageList1: TImageList;
    ToolButton4: TToolButton;
    ActFileNew: TAction;
    Nouveau1: TMenuItem;
    N6: TMenuItem;
    Options2: TMenuItem;
    ActAbout: TAction;
    ActHelpIndex: TAction;
    ToolButton3: TToolButton;
    ToolButton13: TToolButton;
    BUThreadCapture: TBUThread;
    PrinterSetupDialog1: TPrinterSetupDialog;
    ActPreview: TAction;
    Prvisualiser1: TMenuItem;
    ToolButton14: TToolButton;
    ToolButton15: TToolButton;
    PrintDialog1: TPrintDialog;
    ActLogClearAll: TAction;
    ActLogClearSelection: TAction;
    Edition1: TMenuItem;
    Effacertout1: TMenuItem;
    Effacervenementsslectionns1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    BUDragDrop1: TBUDragDrop;
    ActLogRefresh: TAction;
    N7: TMenuItem;
    Raffraichir1: TMenuItem;
    lblLastEvent: TLabel;
    Raffraichir2: TMenuItem;
    N8: TMenuItem;
    Prvisualiser2: TMenuItem;
    ActCaptureTestSystem: TAction;
    N9: TMenuItem;
    Testsystme1: TMenuItem;
    ActCaptureInitSystem: TAction;
    Rinitialisersystme1: TMenuItem;
    ApdComPort1: TApdComPort;
    ActLogSelectAll: TAction;
    ActLogCopy: TAction;
    Slectionnertout1: TMenuItem;
    N10: TMenuItem;
    ActLogInvertSelection: TAction;
    Inverserslection1: TMenuItem;
    ActConfLoad: TAction;
    ActConfSave: TAction;
    mnuConfLoad: TMenuItem;
    mnuConfSave: TMenuItem;
    N11: TMenuItem;
    BUThreadSaveData_Old: TBUThread;
    BURunOnStartup1: TBURunOnStartup;
    ActConfSaveAs: TAction;
    mnuConfSaveAs: TMenuItem;
    Configuration1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ActAppResetAllExecute(Sender: TObject);
    procedure ActAppCloseExecute(Sender: TObject);
    procedure ActOptionsExecute(Sender: TObject);
    procedure ActCaptureStartExecute(Sender: TObject);
    procedure ActCaptureStopExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure ActFileSaveExecute(Sender: TObject);
    procedure ActHelpIndexExecute(Sender: TObject);
    procedure ActAboutExecute(Sender: TObject);
    procedure BUThreadCaptureExecute(Sender: TObject; params: Pointer);
    procedure ActPrintExecute(Sender: TObject);
    procedure ActFileNewExecute(Sender: TObject);
    procedure ActFileOpenExecute(Sender: TObject);
    procedure ActPrintConfExecute(Sender: TObject);
    procedure ActPreviewExecute(Sender: TObject);
    procedure ActLogClearAllExecute(Sender: TObject);
    procedure ActLogClearSelectionExecute(Sender: TObject);
    procedure ActFileSaveAsExecute(Sender: TObject);
    procedure lvEventsListEdited(Sender: TObject; Item: TListItem;
      var S: String);
    procedure lvEventsListDrawItem(Sender: TCustomListView;
      Item: TListItem; Rect: TRect; State: TOwnerDrawState);
    procedure BUDragDrop1Drop(Sender: TObject; Pos: TPoint;
      Value: TStringList);
    procedure ActLogRefreshExecute(Sender: TObject);
    procedure ActCaptureTestSystemExecute(Sender: TObject);
    procedure ActCaptureInitSystemExecute(Sender: TObject);
    procedure ActLogSelectAllExecute(Sender: TObject);
    procedure ActLogInvertSelectionExecute(Sender: TObject);
    procedure BUThreadSaveData_OldExecute(Sender: TObject; params: Pointer);
    procedure ActConfLoadExecute(Sender: TObject);
    procedure ActConfSaveExecute(Sender: TObject);
    procedure ActConfSaveAsExecute(Sender: TObject);
    procedure BUThreadCaptureFinishAll(Sender: TObject);
  private
    procedure App_Init;
    procedure App_RefreshGUIActions;
    procedure App_RefreshGUIColors;
    procedure Log_PrintOrPreview(bPreview: boolean);
    function  App_AskForClearItems(bAll: boolean): integer;
    function  App_AskForStopAcqAndQuit: integer;
    procedure Conf_LoadLastUsedFile;
    { Dclarations prives }
  public
    { Dclarations publiques }
    function  App_OSIsNT: boolean;
    function  App_DayIsNew: boolean;
    function  App_GetLogFileOfTheDay: string;
    procedure App_RefreshGUIMain;
    procedure App_RefreshGUIStatusBar;
  end;

const
  // status bar indexes
  sbLogFileModifiedIndex = 0;
  sbPortSelectedIndex = 1;
  sbCaptureStatusTextIndex = 2;
  sbEventsCountIndex = 3;
  sbInputsStateIndex = 4;

var
  fmMain: TfmMain;
  HThreadCapture: THandle;
  HThreadSaveData: THandle;
  bThreadIsRunning: boolean;
  AppPath: string;
  LogPath: string;
  ConfPath: string;
  AppIniFile: string;
  AppHelpFile: string;
  AppLogFile: string;
  AppActualDay: TDateTime;
  LogFileOfTheDay: string;
  LogOpenedFileName: string;
  LogOpenedFileModified: boolean;
  ConfOpenedFileName: string;
  ConfOpenedFileModified: boolean;
  AppIsStarting: boolean;
  CaptureIsRunning: boolean;
  EventsCountPartial: integer;
  EventsCountTotal: integer;


implementation

uses
  rmMisc, rmForms,

  // use of zlPortIO - in rmPorts - for NT port access
  rmPorts,

  uResStr, uUserPrefs, uLog, uCapture, uConf,
  frmOptions, frmReport01, frmAbout, frmPrintOptions;

{$R *.DFM}

function TfmMain.App_OSIsNT: boolean;
begin
  result := (Win32Platform = VER_PLATFORM_WIN32_NT);
end;

function TfmMain.App_DayIsNew: boolean;
{
var
  nowDate, actualDate: TDate;
  s: string;
}
begin
  try
    {
    s := DateToStr(now);
    nowDate := strToDate(s);
    s := DateToStr(AppActualDay);
    actualDate := strToDate(s);
    result := (nowDate > actualDate);
    }
    result := (Date > AppActualDay);
  except
    result := false;
  end;
end;

procedure TfmMain.FormCreate(Sender: TObject);
begin
  // init app (path, files, log, etc...)
  App_Init;

  // load last used user options
  {
  if fileExists(UserPrefs.ConfLastUsedFile) then
    UserPrefs_Load(UserPrefs.ConfLastUsedFile)
  else
  }
  UserPrefs_Load(AppIniFile);


  {
  // until debug complete
  **********************************************************
  }
  //UserPrefs.LogSaveAutoOnNewDay := false;
  {
  **********************************************************
  }


  // init log
  Log_Init;

  // init conf
  Conf_SetOpenedConfFile(sOpenedFileUntitled);

  // init and test capture system
  ActCaptureInitSystemExecute(nil);
  ActCaptureTestSystemExecute(nil);

  // refresh GUI
  App_RefreshGUIMain;

end;

procedure TfmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  UserPrefs_Save(AppIniFile);
  Log_CheckForSave(not UserPrefs.LogSaveAutoOnExit);
  SaveFormsSizeAndPos(AppIniFile);
end;

procedure TfmMain.App_RefreshGUIMain;
begin
  // refresh actions
  App_RefreshGUIActions;

  // refresh status bar
  App_RefreshGUIStatusBar;

  // refresh GUI controls
  lvEventsList.Enabled := Capture_TestSystemOK;

  // refresh GUI colors
  App_RefreshGUIColors;
end;

procedure TfmMain.App_RefreshGUIActions;
begin
  BUDragDrop1.AcceptDrag := not CaptureIsRunning;
  ActAppClose.Enabled := not CaptureIsRunning;
  ActFileNew.Enabled := not CaptureIsRunning;
  ActFileOpen.Enabled := not CaptureIsRunning;
  ActFileSave.Enabled := not CaptureIsRunning;
  ActFileSaveAs.Enabled := not CaptureIsRunning;
  ActPreview.Enabled := not CaptureIsRunning;
  ActPrint.Enabled := not CaptureIsRunning;
  ActPrintConf.Enabled := not CaptureIsRunning;
  ActOptions.Enabled := not CaptureIsRunning;
  ActConfLoad.Enabled := not CaptureIsRunning;
  ActConfSave.Enabled := not CaptureIsRunning;
  ActConfSaveAs.Enabled := not CaptureIsRunning;
  ActLogSelectAll.Enabled := not CaptureIsRunning;
  ActLogInvertSelection.Enabled := not CaptureIsRunning;
  ActLogClearAll.Enabled := not CaptureIsRunning;
  ActLogClearSelection.Enabled := not CaptureIsRunning;
  ActLogRefresh.Enabled := not CaptureIsRunning;
  ActCaptureStart.Enabled := not CaptureIsRunning;
  ActCaptureStop.Enabled := CaptureIsRunning;
  ActCaptureInitSystem.Enabled := not CaptureIsRunning;
  ActCaptureTestSystem.Enabled := not CaptureIsRunning;
  //ActHelpIndex.Enabled := not CaptureIsRunning;
  //ActAbout.Enabled := not CaptureIsRunning;
end;

procedure TfmMain.App_RefreshGUIStatusBar;
begin
  StatusBar1.Panels[sbLogFileModifiedIndex].text :=
    boolToStr(LogOpenedFileModified, '*', '');
  StatusBar1.Panels[sbPortSelectedIndex].text :=
    Capture_GetPortBaseAddressStr;
  StatusBar1.Panels[sbCaptureStatusTextIndex].text :=
    boolToStr(CaptureIsRunning, sCaptureIsRunning, sCaptureIsStopped);
  StatusBar1.Panels[sbEventsCountIndex].text :=
    format('%d (total : %d)', [EventsCountPartial, EventsCountTotal]);
  StatusBar1.Panels[sbInputsStateIndex].text :=
    '--------';
end;

procedure TfmMain.App_RefreshGUIColors;
var
  i: integer;
begin
  for i := 0 to pred(componentCount) do
  begin
    if components[i] is TListView then
    begin
      TListView(components[i]).color :=
        boolToColor(Capture_TestSystemOK, clWindow, clBtnFace);
    end;
  end;
end;

function TfmMain.App_GetLogFileOfTheDay: string;
begin
  result := LogPath + formatDateTime('yyyy_mm_dd', now) + '.txt';
end;


procedure TfmMain.App_Init;
begin
  AppActualDay := now;

  // init Paths and files
  AppPath := extractFilePath(application.exeName);
  LogPath := AppPath + 'Log\';
  ConfPath := AppPath;
  if not DirectoryExists(LogPath) then
    rmMisc.MakePath(LogPath);

  AppIniFile := changeFileExt(application.exeName, '.ini');
  AppLogFile := changeFileExt(application.exeName, '.log');
  LogFileOfTheDay := App_GetLogFileOfTheDay;
  AppHelpFile := changeFileExt(application.exeName, '.hlp');
  Application.HelpFile := AppHelpFile;

  // refresh action status
  ActHelpIndex.Enabled := fileExists(AppHelpFile);
  ActHelpIndex.Hint :=
    boolToStr(fileExists(AppHelpFile), sHintHelpIndexHelpFileFound, sHintHelpIndexHelpFileNotFound);

  // init Acq
  CaptureIsRunning := false;
end;

procedure TfmMain.Conf_LoadLastUsedFile;
begin
  if fileExists(UserPrefs.ConfLastUsedFile) then
    UserPrefs_Load(UserPrefs.ConfLastUsedFile);
end;

procedure TfmMain.ActAppResetAllExecute(Sender: TObject);
begin
  // reset all
  App_RefreshGUIMain;
end;

procedure TfmMain.ActAppCloseExecute(Sender: TObject);
begin
  Close;
end;

procedure TfmMain.ActOptionsExecute(Sender: TObject);
var
  frm: TfmOptions;
begin
  frm := TfmOptions.create(self);
  try
    frm.getPrefs;
    // select input 1 params
    frm.cbInputList.ItemIndex := 0;
    frm.GetInputParams;
    frm.ShowModal;
  finally
    frm.Free;
  end;
end;

procedure TfmMain.ActCaptureStartExecute(Sender: TObject);
begin
  Capture_InitSystem;
  Capture_TestSystem;
  Capture_Start;
end;

procedure TfmMain.ActCaptureStopExecute(Sender: TObject);
begin
  Capture_Stop;
end;

procedure TfmMain.BUThreadCaptureFinishAll(Sender: TObject);
begin
  bThreadIsRunning := false;
end;

function TfmMain.App_AskForStopAcqAndQuit: integer;
begin
  result := MessageDlg(sAskStopAndQuit, mtConfirmation, [mbYes, mbNo, mbCancel], 0);
end;

function TfmMain.App_AskForClearItems(bAll: boolean): integer;
var
  sMsg: string;
begin
  sMsg := boolToStr(bAll, sAskClearAllItems, sAskClearSelectedItems);
  result := MessageDlg(sMsg, mtConfirmation, [mbYes, mbNo], 0);
end;

procedure TfmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  ret: integer;
begin
  // capture running, ask to know what to do
  if CaptureIsRunning then
  begin
    ret := App_AskForStopAcqAndQuit;
    case ret of
      mrYes : begin
                ActCaptureStopExecute(nil);
                ActFileSaveExecute(nil);
              end;
    end;
    CanClose := (ret = mrYes);
  end

  // capture not running, can close app
  else
    CanClose := true;

end;

procedure TfmMain.ActFileSaveExecute(Sender: TObject);
begin
  if LogOpenedFileName = sOpenedFileUntitled then
    ActFileSaveAsExecute(Sender)
  else
  begin
    Log_SaveToFile(LogOpenedFileName);
    Log_SetOpenedLogModified(False);
  end;
end;

procedure TfmMain.ActFileSaveAsExecute(Sender: TObject);
begin
  with SaveDialog1 do
  begin
    DefaultExt := 'txt';
    InitialDir := LogPath;
    Filter := 'Historiques (*.txt)|*.txt';
    FileName := sOpenedFileUntitled;
    if Execute then
    begin
      Log_SaveToFile(FileName);
      Log_SetOpenedLogFile(FileName);
      Log_SetOpenedLogModified(False);
      LogPath := extractFilePath(FileName);
    end;
  end;
end;

procedure TfmMain.ActHelpIndexExecute(Sender: TObject);
var
  HlpCtx: integer;
begin
  Application.HelpCommand(HELP_CONTENTS, 0);
  {
  HlpCtx := PageControl1.ActivePage.HelpContext;
  application.HelpContext(HlpCtx);
  }
end;

procedure TfmMain.ActAboutExecute(Sender: TObject);
var
  frm: TfmAbout;
begin
  frm := TfmAbout.create(self);
  try
    frm.showModal;
  finally
    frm.Free;
  end;
end;

procedure TfmMain.BUThreadCaptureExecute(Sender: TObject; params: Pointer);
begin
  repeat
    // read inputs
    Capture_ReadInputs;

    // save to file if new day
    Capture_CheckForDayIsNew;

  until (not CaptureIsRunning);

  // fire end capture for GUI refresh
  ActCaptureStopExecute(nil);
end;

procedure TfmMain.BUThreadSaveData_OldExecute(Sender: TObject; params: Pointer);
begin
  repeat
    // save to file if new day
    Capture_CheckForDayIsNew;
  until (not CaptureIsRunning);
end;

procedure TfmMain.ActPrintConfExecute(Sender: TObject);
begin
  PrinterSetupDialog1.execute;
end;

procedure TfmMain.ActPrintExecute(Sender: TObject);
begin
  Log_PrintOrPreview(false);
end;

procedure TfmMain.ActPreviewExecute(Sender: TObject);
begin
  Log_PrintOrPreview(true);
end;

procedure TfmMain.Log_PrintOrPreview(bPreview: boolean);
var
  frm: TFmReport01;
begin
  // check for something to print or preview (abort procedure if no event)
  Log_CheckForEventListNotEmpty;

  {
  // show print options dialog ?
  if lvEventsList.SelCount > 0 then
  begin
    fmPrintOptions.rbLogPrintSelection.Checked := true;
    fmPrintOptions.showModal;
  end
  else
    fmPrintOptions.rbLogPrintAll.Checked := true;
  }

  // preview before print
  frm := TFmReport01.create(self);
  try
    if bPreview then
    begin
      //frm.QuickRep1.zoom := 100;
      frm.QuickRep1.Preview;
    end
    else
      if PrintDialog1.Execute then
        frm.QuickRep1.Print;
  finally
    frm.Free;
  end;
end;

procedure TfmMain.ActFileNewExecute(Sender: TObject);
begin
  Log_New(sOpenedFileUntitled);
end;

procedure TfmMain.ActFileOpenExecute(Sender: TObject);
begin
  with OpenDialog1 do
  begin
    InitialDir := LogPath;
    DefaultExt := 'txt';
    Filter := 'Historiques (*.txt)|*.txt';
    if Execute then
      Log_LoadFromFile(FileName);
  end;
end;


procedure TfmMain.ActLogClearAllExecute(Sender: TObject);
var
  Ret: integer;
begin
  // check for something to clear (abort procedure if no event)
  Log_CheckForEventListNotEmpty;

  // clear all items ?
  ret := App_AskForClearItems(true);
  if ret = mrYes then
    Log_ClearAll;
end;

procedure TfmMain.ActLogClearSelectionExecute(Sender: TObject);
var
  Ret: integer;
begin
  // check for something to clear (abort procedure if no event)
  Log_CheckForEventListNotEmpty;

  // clear selected items ?
  ret := App_AskForClearItems(false);
  if ret = mrYes then
    Log_ClearSelection;
end;

procedure TfmMain.lvEventsListEdited(Sender: TObject; Item: TListItem;
  var S: String);
begin
  Log_SetOpenedLogModified(true);
end;

procedure TfmMain.lvEventsListDrawItem(Sender: TCustomListView;
  Item: TListItem; Rect: TRect; State: TOwnerDrawState);
var
  i, idx: integer;
  bActive,
  bInvert: boolean;
  iMinDuration: integer;
  sLabel: string;
  clTextColor, clBGColor, clBG1, clBG2, clText1, clText2: TColor;
  HorzOffset, VertOffset: integer;
begin
  HorzOffset := rect.left + 6;
  VertOffset := rect.top;
  clBG1 := clGreen;   // clBlue + $8000;
  clBG2 := $0080FFFF;
  clText1 := clLime;
  clText2 := clBlack;

  with TCustomListView(sender) do
  begin
    // draw text in color
    try

      // item is selected
      if odSelected in state then
      begin

        // draw background - left part
        canvas.Brush.Color := clBG1;
        canvas.FillRect(
          classes.rect(
            rect.left,
            rect.top,
            rect.left + lvEventsList.Columns[0].width,
            rect.bottom));

        // draw caption - left part
        canvas.Font.Color := clText1;
        canvas.font.style := canvas.font.style + [fsBold];
        canvas.textOut(HorzOffset, VertOffset, '> ' + item.caption);

        // draw background - right part
        canvas.Brush.Color := clBG2;
        canvas.FillRect(
          classes.rect(
            rect.left + lvEventsList.Columns[0].width,
            rect.top,
            rect.right,
            rect.bottom));
        canvas.Font.Color := clText2;
        canvas.font.style := canvas.font.style - [fsBold];

      end
      else

      // item is not selected
      begin
        idx := strToInt(item.SubItems[0]);

        // get all params, but use only text and BG colors
        Log_GetEventParams(
          UserPrefs,
          idx,
          bActive,
          bInvert,
          iMinDuration,
          sLabel,
          clTextColor,
          clBGColor);

        // draw background
        canvas.Brush.Color := clBGColor;
        canvas.FillRect(rect);

        // draw text
        Canvas.Font.Color := clTextColor;
        canvas.textOut(HorzOffset, VertOffset, item.caption);

      end;

      // draw subitems
      for i := 0 to pred(lvEventsList.Columns.Count) - 1 do
      begin
        HorzOffset := HorzOffset + lvEventsList.Columns[i].width;
        canvas.textOut(HorzOffset, VertOffset, item.SubItems[i]);
      end;

    except
      canvas.Font.Color := clRed;
      canvas.Brush.Color := clWindow;
      canvas.textOut(HorzOffset, VertOffset, '---');
    end;
  end;
end;

procedure TfmMain.BUDragDrop1Drop(Sender: TObject; Pos: TPoint;
  Value: TStringList);
begin
  if BUDragDrop1.Files.Count > 0 then
  begin
    Log_CheckForSave(true);
    Log_LoadFromFile(BUDragDrop1.Files[0]);
  end;
end;

procedure TfmMain.ActLogRefreshExecute(Sender: TObject);
begin
  Log_RefreshView;
end;

procedure TfmMain.ActCaptureTestSystemExecute(Sender: TObject);
var
  OK: boolean;
begin
  lblLastEvent.caption := 'Test systme en cours...';
  delay(200, true);
  OK := Capture_TestSystem;
  lblLastEvent.color := clBlack;
  lblLastEvent.font.color :=
    boolToColor(OK, clLime, clRed);
  lblLastEvent.caption :=
    rmMisc.boolToStr(OK, 'Systme prt', 'Systme non prt !');
end;

procedure TfmMain.ActCaptureInitSystemExecute(Sender: TObject);
begin
  fmMain.lblLastEvent.caption := 'Rinit. systme en cours...';
  delay(200, true);
  if Capture_InitSystem then
    ActCaptureTestSystemExecute(nil);
end;

procedure TfmMain.ActLogSelectAllExecute(Sender: TObject);
begin
  // check for something to clear (abort procedure if no event)
  Log_CheckForEventListNotEmpty;

  Log_SelectAll;
end;

procedure TfmMain.ActLogInvertSelectionExecute(Sender: TObject);
begin
  // check for something to clear (abort procedure if no event)
  Log_CheckForEventListNotEmpty;

  Log_InvertSelection;
end;


procedure TfmMain.ActConfLoadExecute(Sender: TObject);
begin
  with OpenDialog1 do
  begin
    DefaultExt := 'icf'; // icf for Input Conf File
    InitialDir := ConfPath;
    Filter := 'Configuration des entres (*.icf)|*.icf';
    if Execute then
      Conf_LoadFromFile(FileName);
  end;
end;

procedure TfmMain.ActConfSaveExecute(Sender: TObject);
begin
  if ConfOpenedFileName = sOpenedFileUntitled then
    ActConfSaveAsExecute(Sender)
  else
    Conf_SaveToFile(ConfOpenedFileName);
end;

procedure TfmMain.ActConfSaveAsExecute(Sender: TObject);
begin
  with SaveDialog1 do
  begin
    DefaultExt := 'icf'; // icf for Input Conf File
    InitialDir := ConfPath;
    Filter := 'Configuration des entres (*.icf)|*.icf';
    FileName := sOpenedFileUntitled;
    if Execute then
    begin
      Conf_SaveToFile(FileName);
      ConfPath := extractFilePath(FileName);
    end;
  end;
end;



initialization
  DecimalSeparator := '.';



end.
