program ADDatAcq;

uses
  Forms,
  dialogs,
  SysUtils,
  rmForms,
  frmMain in 'frmMain.pas' {fmMain},
  frmInputConfig in 'frmInputConfig.pas' {fmInputConfig},
  ResStr in 'ResStr.pas',
  frmAbout in 'frmAbout.pas' {fmAbout},
  uDataRead in 'uDataRead.pas',
  frmOptions in 'frmOptions.pas' {fmOptions},
  uChartSeries in 'uChartSeries.pas',
  frmProgress in 'frmProgress.pas' {fmProgress},
  uDataRecord in 'uDataRecord.pas',
  frmPlugins in 'frmPlugins.pas' {fmPlugins};

{$R *.RES}

var
  OldPluginFileName: string;


begin
  Application.Initialize;
  Application.CreateForm(TfmMain, fmMain);
  Application.CreateForm(TfmProgress, fmProgress);
  Application.CreateForm(TfmPlugins, fmPlugins);
  rmForms.LoadFormsSizeAndPos(AppIniFile);
  //fmMain.UserPrefs_LoadLastUsedConfFile;
  // load plugin, for test
  OldPluginFileName := plugin.PluginFileName;
  fmPlugins.Plugin_GetAllPluginsDesc;
  fmPlugins.Plugin_SetActive(OldPluginFileName);
  fmMain.ActChartReinitSeriesExecute(nil);
  Application.Run;
end.
